import { createMap, forMember, ignore, Mapper } from '@automapper/core';
import { AutomapperProfile, InjectMapper } from '@automapper/nestjs';
import { Injectable } from '@nestjs/common';
import { ConfigurationPresenter } from '../adapters/primaries/configuration.presenter';
import { ConfigurationMessagerPresenter } from '../adapters/secondaries/configuration-messager.presenter';
import { CreateConfigurationRequest } from '../domain/dtos/create-configuration.request';
import { UpdateConfigurationRequest } from '../domain/dtos/update-configuration.request';
import { Configuration } from '../domain/entities/configuration';

@Injectable()
export class ConfigurationProfile extends AutomapperProfile {
  constructor(@InjectMapper() mapper: Mapper) {
    super(mapper);
  }

  override get profile() {
    return (mapper: any) => {
      createMap(mapper, Configuration, ConfigurationPresenter);

      createMap(mapper, CreateConfigurationRequest, Configuration);

      createMap(
        mapper,
        UpdateConfigurationRequest,
        Configuration,
        forMember((dest) => dest.uuid, ignore()),
      );

      createMap(mapper, Configuration, ConfigurationMessagerPresenter);
    };
  }
}
